--- gcc/tree-vectorizer.h.jj	2021-09-27 10:47:15.839084866 +0200
+++ gcc/tree-vectorizer.h	2021-10-11 13:46:55.169767481 +0200
@@ -1701,14 +1701,22 @@ get_dr_vinfo_offset (vec_info *vinfo,
 }
 
 
+/* Return the vect cost model for LOOP.  */
+static inline enum vect_cost_model
+loop_cost_model (loop_p loop)
+{
+  if (loop != NULL
+      && loop->force_vectorize
+      && flag_simd_cost_model != VECT_COST_MODEL_DEFAULT)
+    return flag_simd_cost_model;
+  return flag_vect_cost_model;
+}
+
 /* Return true if the vect cost model is unlimited.  */
 static inline bool
 unlimited_cost_model (loop_p loop)
 {
-  if (loop != NULL && loop->force_vectorize
-      && flag_simd_cost_model != VECT_COST_MODEL_DEFAULT)
-    return flag_simd_cost_model == VECT_COST_MODEL_UNLIMITED;
-  return (flag_vect_cost_model == VECT_COST_MODEL_UNLIMITED);
+  return loop_cost_model (loop) == VECT_COST_MODEL_UNLIMITED;
 }
 
 /* Return true if the loop described by LOOP_VINFO is fully-masked and
--- gcc/tree-vect-loop.c.jj	2021-09-22 09:25:15.199030463 +0200
+++ gcc/tree-vect-loop.c	2021-10-11 13:48:33.183366790 +0200
@@ -1850,7 +1850,7 @@ vect_analyze_loop_costing (loop_vec_info
 
   /* If using the "very cheap" model. reject cases in which we'd keep
      a copy of the scalar code (even if we might be able to vectorize it).  */
-  if (flag_vect_cost_model == VECT_COST_MODEL_VERY_CHEAP
+  if (loop_cost_model (loop) == VECT_COST_MODEL_VERY_CHEAP
       && (LOOP_VINFO_PEELING_FOR_ALIGNMENT (loop_vinfo)
 	  || LOOP_VINFO_PEELING_FOR_GAPS (loop_vinfo)
 	  || LOOP_VINFO_PEELING_FOR_NITER (loop_vinfo)))
@@ -1922,7 +1922,7 @@ vect_analyze_loop_costing (loop_vec_info
   /* If the vector loop needs multiple iterations to be beneficial then
      things are probably too close to call, and the conservative thing
      would be to stick with the scalar code.  */
-  if (flag_vect_cost_model == VECT_COST_MODEL_VERY_CHEAP
+  if (loop_cost_model (loop) == VECT_COST_MODEL_VERY_CHEAP
       && min_profitable_estimate > (int) vect_vf_for_cost (loop_vinfo))
     {
       if (dump_enabled_p ())
--- gcc/tree-vect-data-refs.c.jj	2021-09-30 17:12:15.238586878 +0200
+++ gcc/tree-vect-data-refs.c	2021-10-11 13:51:48.491576058 +0200
@@ -2236,7 +2236,7 @@ vect_enhance_data_refs_alignment (loop_v
         {
           unsigned max_allowed_peel
 	    = param_vect_max_peeling_for_alignment;
-	  if (flag_vect_cost_model <= VECT_COST_MODEL_CHEAP)
+	  if (loop_cost_model (loop) <= VECT_COST_MODEL_CHEAP)
 	    max_allowed_peel = 0;
           if (max_allowed_peel != (unsigned)-1)
             {
@@ -2334,7 +2334,7 @@ vect_enhance_data_refs_alignment (loop_v
   do_versioning
     = (optimize_loop_nest_for_speed_p (loop)
        && !loop->inner /* FORNOW */
-       && flag_vect_cost_model > VECT_COST_MODEL_CHEAP);
+       && loop_cost_model (loop) > VECT_COST_MODEL_CHEAP);
 
   if (do_versioning)
     {
@@ -3751,7 +3751,9 @@ vect_prune_runtime_alias_test_list (loop
   unsigned int count = (comp_alias_ddrs.length ()
 			+ check_unequal_addrs.length ());
 
-  if (count && flag_vect_cost_model == VECT_COST_MODEL_VERY_CHEAP)
+  if (count
+      && (loop_cost_model (LOOP_VINFO_LOOP (loop_vinfo))
+	  == VECT_COST_MODEL_VERY_CHEAP))
     return opt_result::failure_at
       (vect_location, "would need a runtime alias check\n");
 
@@ -3760,7 +3762,7 @@ vect_prune_runtime_alias_test_list (loop
 		     "improved number of alias checks from %d to %d\n",
 		     may_alias_ddrs.length (), count);
   unsigned limit = param_vect_max_version_for_alias_checks;
-  if (flag_simd_cost_model == VECT_COST_MODEL_CHEAP)
+  if (loop_cost_model (LOOP_VINFO_LOOP (loop_vinfo)) == VECT_COST_MODEL_CHEAP)
     limit = param_vect_max_version_for_alias_checks * 6 / 10;
   if (count > limit)
     return opt_result::failure_at
--- libgomp/testsuite/libgomp.c/scan-11.c.jj	2021-10-10 12:12:28.366333440 +0200
+++ libgomp/testsuite/libgomp.c/scan-11.c	2021-10-11 13:53:36.090038707 +0200
@@ -1,5 +1,5 @@
 /* { dg-require-effective-target size32plus } */
-/* { dg-additional-options "-O2 -fvect-cost-model=cheap -fopenmp -fdump-tree-vect-details" } */
+/* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
 /* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
--- libgomp/testsuite/libgomp.c/scan-12.c.jj	2021-10-10 12:12:28.366333440 +0200
+++ libgomp/testsuite/libgomp.c/scan-12.c	2021-10-11 13:53:40.186980174 +0200
@@ -1,5 +1,5 @@
 /* { dg-require-effective-target size32plus } */
-/* { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details" } */
+/* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
 /* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
--- libgomp/testsuite/libgomp.c/scan-13.c.jj	2021-10-10 12:12:28.366333440 +0200
+++ libgomp/testsuite/libgomp.c/scan-13.c	2021-10-11 13:53:43.538932282 +0200
@@ -1,5 +1,5 @@
 /* { dg-require-effective-target size32plus } */
-/* { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details" } */
+/* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
 /* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
--- libgomp/testsuite/libgomp.c/scan-14.c.jj	2021-10-10 12:12:28.366333440 +0200
+++ libgomp/testsuite/libgomp.c/scan-14.c	2021-10-11 13:53:46.637888006 +0200
@@ -1,5 +1,5 @@
 /* { dg-require-effective-target size32plus } */
-/* { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details" } */
+/* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
 /* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
--- libgomp/testsuite/libgomp.c/scan-15.c.jj	2021-10-10 12:12:28.366333440 +0200
+++ libgomp/testsuite/libgomp.c/scan-15.c	2021-10-11 13:53:49.891841513 +0200
@@ -1,5 +1,5 @@
 /* { dg-require-effective-target size32plus } */
-/* { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details" } */
+/* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
 /* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
--- libgomp/testsuite/libgomp.c/scan-16.c.jj	2021-10-10 12:12:28.367333426 +0200
+++ libgomp/testsuite/libgomp.c/scan-16.c	2021-10-11 13:53:52.908798405 +0200
@@ -1,5 +1,5 @@
 /* { dg-require-effective-target size32plus } */
-/* { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details" } */
+/* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
 /* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
--- libgomp/testsuite/libgomp.c/scan-17.c.jj	2021-10-10 12:12:28.367333426 +0200
+++ libgomp/testsuite/libgomp.c/scan-17.c	2021-10-11 13:53:55.940755086 +0200
@@ -1,5 +1,5 @@
 /* { dg-require-effective-target size32plus } */
-/* { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details" } */
+/* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
 /* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
--- libgomp/testsuite/libgomp.c/scan-18.c.jj	2021-10-10 12:12:28.367333426 +0200
+++ libgomp/testsuite/libgomp.c/scan-18.c	2021-10-11 13:53:58.739715092 +0200
@@ -1,5 +1,5 @@
 /* { dg-require-effective-target size32plus } */
-/* { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details" } */
+/* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
 /* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
--- libgomp/testsuite/libgomp.c/scan-19.c.jj	2021-10-10 12:12:28.367333426 +0200
+++ libgomp/testsuite/libgomp.c/scan-19.c	2021-10-11 13:54:01.640673646 +0200
@@ -1,5 +1,5 @@
 /* { dg-require-effective-target size32plus } */
-/* { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details" } */
+/* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
 /* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
--- libgomp/testsuite/libgomp.c/scan-20.c.jj	2021-10-10 12:12:28.367333426 +0200
+++ libgomp/testsuite/libgomp.c/scan-20.c	2021-10-11 13:54:05.757614824 +0200
@@ -1,5 +1,5 @@
 /* { dg-require-effective-target size32plus } */
-/* { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details" } */
+/* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" } */
 /* { dg-additional-options "-msse2" { target sse2_runtime } } */
 /* { dg-additional-options "-mavx" { target avx_runtime } } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } } */
--- libgomp/testsuite/libgomp.c/scan-21.c.jj	2021-10-10 12:12:28.367333426 +0200
+++ libgomp/testsuite/libgomp.c/scan-21.c	2021-10-11 13:54:09.852556318 +0200
@@ -1,6 +1,6 @@
 /* { dg-require-effective-target size32plus } */
 /* { dg-require-effective-target avx_runtime } */
-/* { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details -msse2 -mno-sse3" } */
+/* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details -msse2 -mno-sse3" } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" } } */
 
 #include "scan-13.c"
--- libgomp/testsuite/libgomp.c/scan-22.c.jj	2021-10-10 12:12:28.367333426 +0200
+++ libgomp/testsuite/libgomp.c/scan-22.c	2021-10-11 13:54:14.516489679 +0200
@@ -1,6 +1,6 @@
 /* { dg-require-effective-target size32plus } */
 /* { dg-require-effective-target avx_runtime } */
-/* { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details -msse2 -mno-sse3" } */
+/* { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details -msse2 -mno-sse3" } */
 /* { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" } } */
 
 #include "scan-17.c"
--- libgomp/testsuite/libgomp.c++/scan-9.C.jj	2021-10-10 12:12:28.000000000 +0200
+++ libgomp/testsuite/libgomp.c++/scan-9.C	2021-10-11 13:54:47.256021904 +0200
@@ -1,5 +1,5 @@
 // { dg-require-effective-target size32plus }
-// { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details" }
+// { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
 // { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
--- libgomp/testsuite/libgomp.c++/scan-10.C.jj	2021-10-10 12:12:28.000000000 +0200
+++ libgomp/testsuite/libgomp.c++/scan-10.C	2021-10-11 13:54:50.123980925 +0200
@@ -1,5 +1,5 @@
 // { dg-require-effective-target size32plus }
-// { dg-additional-options "-O2 -fvect-cost-model=cheap -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
 // { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
--- libgomp/testsuite/libgomp.c++/scan-11.C.jj	2021-10-10 12:12:28.000000000 +0200
+++ libgomp/testsuite/libgomp.c++/scan-11.C	2021-10-11 13:54:54.256921875 +0200
@@ -1,5 +1,5 @@
 // { dg-require-effective-target size32plus }
-// { dg-additional-options "-O2 -fvect-cost-model=cheap -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
 // { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
--- libgomp/testsuite/libgomp.c++/scan-12.C.jj	2021-10-10 12:12:28.000000000 +0200
+++ libgomp/testsuite/libgomp.c++/scan-12.C	2021-10-11 13:54:57.077881570 +0200
@@ -1,5 +1,5 @@
 // { dg-require-effective-target size32plus }
-// { dg-additional-options "-O2 -fvect-cost-model=cheap -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
 // { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
--- libgomp/testsuite/libgomp.c++/scan-13.C.jj	2021-10-10 12:12:28.000000000 +0200
+++ libgomp/testsuite/libgomp.c++/scan-13.C	2021-10-11 13:55:00.164837465 +0200
@@ -1,5 +1,5 @@
 // { dg-require-effective-target size32plus }
-// { dg-additional-options "-O2 -fvect-cost-model=cheap -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
 // { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
--- libgomp/testsuite/libgomp.c++/scan-14.C.jj	2021-10-10 12:12:28.000000000 +0200
+++ libgomp/testsuite/libgomp.c++/scan-14.C	2021-10-11 13:55:03.960783227 +0200
@@ -1,5 +1,5 @@
 // { dg-require-effective-target size32plus }
-// { dg-additional-options "-O2 -fvect-cost-model=cheap -fopenmp -fdump-tree-vect-details" }
+// { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
 // { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
--- libgomp/testsuite/libgomp.c++/scan-15.C.jj	2021-10-10 12:12:28.000000000 +0200
+++ libgomp/testsuite/libgomp.c++/scan-15.C	2021-10-11 13:55:06.864741739 +0200
@@ -1,5 +1,5 @@
 // { dg-require-effective-target size32plus }
-// { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details" }
+// { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
 // { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }
--- libgomp/testsuite/libgomp.c++/scan-16.C.jj	2021-10-10 12:12:28.000000000 +0200
+++ libgomp/testsuite/libgomp.c++/scan-16.C	2021-10-11 13:55:09.861698918 +0200
@@ -1,5 +1,5 @@
 // { dg-require-effective-target size32plus }
-// { dg-additional-options "-O2 -fopenmp -fvect-cost-model=cheap -fdump-tree-vect-details" }
+// { dg-additional-options "-O2 -fopenmp -fdump-tree-vect-details" }
 // { dg-additional-options "-msse2" { target sse2_runtime } }
 // { dg-additional-options "-mavx" { target avx_runtime } }
 // { dg-final { scan-tree-dump-times "vectorized \[2-6] loops" 2 "vect" { target sse2_runtime } } }